'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp, _initialiseProps;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactBootstrapTable = require('react-bootstrap-table');

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

var _CustomDateRangeFilter = require('./filters/CustomDateRangeFilter/CustomDateRangeFilter');

var _CustomDateRangeFilter2 = _interopRequireDefault(_CustomDateRangeFilter);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function getCustomFilter(filterHandler, customFilterParameters) {
    return _react2.default.createElement(_CustomDateRangeFilter2.default, {
        filterHandler: filterHandler,
        columnKey: customFilterParameters.columnKey,
        defaultValue: customFilterParameters.defaultValue
    });
}

var DataTable = (_temp = _class = function (_React$Component) {
    _inherits(DataTable, _React$Component);

    function DataTable(props) {
        _classCallCheck(this, DataTable);

        var _this = _possibleConstructorReturn(this, (DataTable.__proto__ || Object.getPrototypeOf(DataTable)).call(this, props));

        _initialiseProps.call(_this);

        _this.state = {
            showFilters: false,
            clearFilters: false,
            defaultFiltersSet: false
        };
        _this.colRef = {};
        _this._hasMounted = false;
        return _this;
    }

    _createClass(DataTable, [{
        key: 'componentWillMount',
        value: function componentWillMount() {
            this.checkFilters();
        }
    }, {
        key: 'componentDidMount',
        value: function componentDidMount() {
            this._hasMounted = true;
        }
    }, {
        key: 'componentWillUpdate',
        value: function componentWillUpdate(nextProps, nextState) {
            if (nextState.clearFilters) this.clearAllFilters();
        }
    }, {
        key: 'preventClientSideSort',


        /* eslint-disable class-methods-use-this */
        value: function preventClientSideSort() {
            return false;
        }
    }, {
        key: 'renderShowsTotal',
        value: function renderShowsTotal(start, to, total) {
            return _react2.default.createElement(
                'div',
                { style: { float: 'right', fontSize: '10px', marginTop: '4px', marginRight: '-66px' } },
                'Showing ',
                start,
                ' to ',
                to,
                ' of ',
                total,
                ' Results'
            );
        }
        /* eslint-enable class-methods-use-this */

    }, {
        key: 'render',
        value: function render() {
            var _this2 = this;

            var _props = this.props,
                keyField = _props.keyField,
                defaultSort = _props.defaultSort,
                tableColumns = _props.tableColumns,
                tableData = _props.tableData,
                dataTotalSize = _props.dataTotalSize,
                onPageChange = _props.onPageChange,
                onSizePerPageList = _props.onSizePerPageList,
                onSortChange = _props.onSortChange,
                currentPage = _props.currentPage,
                sizePerPage = _props.sizePerPage,
                sortName = _props.sortName,
                sortOrder = _props.sortOrder;


            var options = {
                paginationShowsTotal: this.renderShowsTotal,
                sizePerPage: sizePerPage,
                sizePerPageList: [10, 25, 50, 100],
                onSizePerPageList: onSizePerPageList,
                onSortChange: onSortChange,
                searchField: this.searchBox,
                page: currentPage,
                sortName: sortName,
                sortOrder: sortOrder,
                onPageChange: onPageChange,
                btnGroup: this.createCustomButtonGroup,
                onFilterChange: this.props.onFilterChange,
                exportCSVBtn: this.createCustomExportCSVButton,
                onExportToCSV: this.props.onExportToCSV
            };

            // Add sort options
            if (defaultSort) {
                options.defaultSortName = defaultSort[0];
                options.defaultSortOrder = defaultSort[1].toLowerCase();
            }

            var tableHeaderColumns = Object.prototype.toString.call(tableColumns) === '[object Array]' ? tableColumns.map(function (column) {
                // Set column defaults
                var thisRef = function thisRef(c) {
                    _this2.colRef[column.key] = c;
                };
                var colProps = {
                    ref: thisRef,
                    dataField: column.key,
                    key: column.key,
                    dataAlign: 'center',
                    dataSort: true,
                    sortFunc: _this2.preventClientSideSort,
                    hidden: false,
                    width: undefined,
                    filter: undefined,
                    className: '' + (_this2.state.showFilters ? '' : 'hide-filter')
                };

                // add data formatting
                if (column.dataFormat) colProps.dataFormat = column.dataFormat;

                // add data formatting extra data
                if (column.formatExtraData) colProps.formatExtraData = column.formatExtraData;

                // make column unsortable
                if (column.searchable === false) colProps.dataSort = false;

                // make column hidden
                if (column.hidden) colProps.hidden = true;

                // set column width
                if (column.width) colProps.width = column.width.toString();

                // prevent column csv export
                if (typeof column.export !== 'undefined' && !column.export) colProps.export = false;

                // set column filter
                var defaultValue = '';
                if (!_this2._hasMounted && column.defaultValue) defaultValue = column.defaultValue;
                var colFilter = column.filter;
                if (typeof colFilter === 'undefined') {
                    colFilter = '';
                    if (column.searchable !== false) colFilter = 'TextFilter'; // default, if searchable
                }
                switch (colFilter) {
                    case 'TextFilter':
                        {
                            colProps.filter = {
                                type: 'TextFilter',
                                placeholder: ' ',
                                defaultValue: defaultValue
                            };
                            break;
                        }
                    case 'SelectFilter':
                        {
                            colProps.filter = {
                                type: 'SelectFilter',
                                options: column.filterOptions,
                                defaultValue: defaultValue
                            };
                            break;
                        }
                    case 'NumberFilter':
                        {
                            colProps.filter = {
                                type: 'NumberFilter',
                                placeholder: ' ',
                                numberComparators: ['=', '>', '>=', '<', '<=', '!=', '...'],
                                withoutEmptyComparatorOption: true,
                                defaultValue: defaultValue
                            };
                            break;
                        }
                    case 'CustomDateRangeFilter':
                        {
                            colProps.filter = {
                                type: 'CustomFilter',
                                getElement: getCustomFilter,
                                customFilterParameters: {
                                    columnKey: column.key,
                                    defaultValue: defaultValue
                                }
                            };
                            break;
                        }
                    default:
                        {
                            break;
                        }
                }

                return _react2.default.createElement(
                    _reactBootstrapTable.TableHeaderColumn,
                    colProps,
                    column.title
                );
            }) : [];

            var csvFileName = 'exportDownload_' + (0, _moment2.default)().format('YYYY-MM-DD_HH-mm') + '.csv';

            return _react2.default.createElement(
                'div',
                { style: { position: 'relative' } },
                _react2.default.createElement(
                    _reactBootstrapTable.BootstrapTable,
                    {
                        data: tableData || [],
                        exportCSV: true,
                        csvFileName: csvFileName,
                        remote: true,
                        search: true,
                        striped: true,
                        hover: true,
                        pagination: true,
                        fetchInfo: { dataTotalSize: dataTotalSize },
                        options: options,
                        keyField: keyField
                    },
                    tableHeaderColumns
                )
            );
        }
    }]);

    return DataTable;
}(_react2.default.Component), _initialiseProps = function _initialiseProps() {
    var _this3 = this;

    this.createCustomExportCSVButton = function () {
        var DataTableExportData = _this3.props.DataTableExportData;

        if (DataTableExportData && DataTableExportData.fetching) {
            return _react2.default.createElement(
                'div',
                {
                    btnText: '',
                    className: 'table-button table-button-menu-item'
                },
                _react2.default.createElement(
                    'span',
                    { className: 'export-icon' },
                    _react2.default.createElement('b', null)
                ),
                'Preparing'
            );
        } else if (DataTableExportData && DataTableExportData.fetched) {
            return _react2.default.createElement(
                _reactBootstrapTable.ExportCSVButton,
                {
                    btnText: '',
                    className: 'table-button table-button-menu-item'
                },
                _react2.default.createElement(
                    'span',
                    { className: 'export-icon' },
                    _react2.default.createElement('b', null)
                ),
                'Download'
            );
        }
        return _react2.default.createElement(
            _reactBootstrapTable.ExportCSVButton,
            {
                btnText: '',
                className: 'table-button table-button-menu-item'
            },
            _react2.default.createElement(
                'span',
                { className: 'export-icon' },
                _react2.default.createElement('b', null)
            ),
            'Export'
        );
    };

    this.checkFilters = function () {
        var showFilters = false;
        if (Object.prototype.toString.call(_this3.props.tableColumns) === '[object Array]') {
            _this3.props.tableColumns.forEach(function (col) {
                if (!showFilters) {
                    if (col.filter && col.filter === 'NumberFilter') {
                        if (col.defaultValue && col.defaultValue.number) showFilters = true;
                    } else if (col.defaultValue) showFilters = true;
                }
            });
        }
        _this3.state = {
            showFilters: showFilters,
            defaultFiltersSet: showFilters
        };
    };

    this.startClearingAllFilters = function () {
        _this3.props.startClearingFilters(); // - this to stop firing, but doesn't update until too late
        _this3.setState({
            clearFilters: true
        });
    };

    this.clearAllFilters = function () {
        if (Object.prototype.toString.call(_this3.props.tableColumns) === '[object Array]') {
            _this3.props.tableColumns.forEach(function (col) {
                if (col.filter && col.filter.substring(0, 6) === 'Custom') {
                    _this3.colRef[col.key].refs.customFilter.customCleanFiltered();
                } else if (col.filter && col.filter === 'NumberFilter') {
                    _this3.colRef[col.key].applyFilter({
                        comparator: col.defaultValue.comparator
                    }); // retain comparator
                } else {
                    _this3.colRef[col.key].cleanFiltered();
                }
            });
        }
        _this3.setState({
            clearFilters: false
        });
        _this3.props.clearFilters();
    };

    this.toggleFilters = function () {
        _this3.setState({
            showFilters: !_this3.state.showFilters
        });
    };

    this.createCustomButtonGroup = function (props) {
        var filtersType = 'hidden';
        if (_this3.state.showFilters) {
            if (_this3.props.columnFilters && _this3.props.columnFilters.length > 0 || _this3.props.filtersPristine && _this3.state.defaultFiltersSet) {
                filtersType = 'filtered';
            } else {
                filtersType = 'shown';
            }
        }
        return _react2.default.createElement(
            _reactBootstrapTable.ButtonGroup,
            { className: 'table-button-menu', sizeClass: 'btn-group-md' },
            _react2.default.createElement(
                'button',
                {
                    className: 'table-button table-button-menu-item',
                    onClick: _this3.props.refreshTable
                },
                _react2.default.createElement(
                    'span',
                    { className: 'refresh-icon' },
                    _react2.default.createElement('b', null)
                )
            ),
            filtersType === 'shown' && _react2.default.createElement(
                'button',
                {
                    className: 'table-button table-button-menu-item',
                    onClick: _this3.toggleFilters
                },
                _react2.default.createElement(
                    'span',
                    { className: 'filter-icon filter-icon-shown' },
                    _react2.default.createElement('b', null)
                ),
                'Filter'
            ),
            filtersType === 'filtered' && _react2.default.createElement(
                'button',
                {
                    className: 'table-button table-button-menu-item',
                    onClick: _this3.startClearingAllFilters
                },
                _react2.default.createElement(
                    'span',
                    { className: 'filter-icon filter-icon-clear' },
                    _react2.default.createElement('b', null)
                ),
                'Clear Filters'
            ),
            filtersType === 'hidden' && _react2.default.createElement(
                'button',
                {
                    className: 'table-button table-button-menu-item',
                    onClick: _this3.toggleFilters
                },
                _react2.default.createElement(
                    'span',
                    { className: 'filter-icon' },
                    _react2.default.createElement('b', null)
                ),
                'Filter'
            ),
            props.exportCSVBtn,
            _this3.props.extraButtons && _this3.props.extraButtons()
        );
    };

    this.searchBox = function () {
        return _react2.default.createElement('input', {
            type: 'text',
            defaultValue: _this3.props.searchValue,
            placeholder: 'Search',
            onChange: _this3.props.onSearchChange
        });
    };
}, _temp);


DataTable.propTypes = {
    DataTableExportData: _propTypes2.default.object,
    keyField: _propTypes2.default.string.isRequired,
    extraButtons: _propTypes2.default.func,
    defaultSort: _propTypes2.default.array,
    tableColumns: _propTypes2.default.array.isRequired,
    tableData: _propTypes2.default.any,
    dataTotalSize: _propTypes2.default.number.isRequired,
    onPageChange: _propTypes2.default.func.isRequired,
    onSizePerPageList: _propTypes2.default.func.isRequired,
    onSortChange: _propTypes2.default.func.isRequired,
    onSearchChange: _propTypes2.default.func.isRequired,
    onFilterChange: _propTypes2.default.func.isRequired,
    onExportToCSV: _propTypes2.default.func.isRequired,
    currentPage: _propTypes2.default.number.isRequired,
    sizePerPage: _propTypes2.default.number.isRequired,
    refreshTable: _propTypes2.default.func.isRequired,
    sortName: _propTypes2.default.string,
    sortOrder: _propTypes2.default.string,
    searchValue: _propTypes2.default.string,
    startClearingFilters: _propTypes2.default.func.isRequired,
    clearFilters: _propTypes2.default.func.isRequired,
    filtersPristine: _propTypes2.default.bool.isRequired,
    columnFilters: _propTypes2.default.array
};

DataTable.defaultProps = {
    DataTableExportData: null,
    extraButtons: null,
    defaultSort: null,
    tableData: null,
    sortName: undefined,
    sortOrder: undefined,
    searchValue: undefined,
    columnFilters: undefined
};

exports.default = DataTable;