'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

var _reactDayPicker = require('react-day-picker');

var _getPosition = require('./getPosition');

var _getPosition2 = _interopRequireDefault(_getPosition);

var _DateRangeInputField = require('./DateRangeInputField');

var _DateRangeInputField2 = _interopRequireDefault(_DateRangeInputField);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var CustomDateFilter = function (_React$Component) {
    _inherits(CustomDateFilter, _React$Component);

    function CustomDateFilter(props) {
        _classCallCheck(this, CustomDateFilter);

        var _this = _possibleConstructorReturn(this, (CustomDateFilter.__proto__ || Object.getPrototypeOf(CustomDateFilter)).call(this, props));

        _this.handleDayClick = function (day) {
            var range = _reactDayPicker.DateUtils.addDayToRange(day, _this.state);
            _this.setState(range);
        };

        _this.handleResetClick = function () {
            _this.setState({
                from: null,
                to: null
            });
        };

        _this.handleDayClick = _this.handleDayClick.bind(_this);
        _this.handleResetClick = _this.handleResetClick.bind(_this);
        _this.togglePicker = _this.togglePicker.bind(_this);
        _this.positionPicker = _this.positionPicker.bind(_this);
        _this.windowClick = _this.windowClick.bind(_this);
        _this.filter = _this.filter.bind(_this);
        _this.customCleanFiltered = _this.customCleanFiltered.bind(_this);
        _this.setDisplayValue = _this.setDisplayValue.bind(_this);
        _this.state = {
            showPicker: false,
            topPosition: 0,
            leftPosition: -1000,
            from: null,
            to: null,
            displayValue: ''
        };
        return _this;
    }

    _createClass(CustomDateFilter, [{
        key: 'componentWillMount',
        value: function componentWillMount() {
            if (this.props.defaultValue && this.props.defaultValue.from) {
                this.setState({ from: this.props.defaultValue.from });
                if (this.props.defaultValue.to) this.setState({ to: this.props.defaultValue.to });
                this.setDisplayValue(this.props.defaultValue.from, this.props.defaultValue.to);
            }
        }
    }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
            this.removeEvents();
        }
    }, {
        key: 'setDisplayValue',
        value: function setDisplayValue(fromDate, toDate) {
            var displayValue = '';
            if (_moment2.default.isDate(fromDate)) {
                if (_moment2.default.isDate(toDate)) {
                    displayValue = '\n                ' + (0, _moment2.default)(fromDate).format('DD/MM/YYYY') + '\n                {\' - \'}\n                ' + (0, _moment2.default)(toDate).format('DD/MM/YYYY') + '\n                ';
                } else displayValue = (0, _moment2.default)(fromDate).format('DD/MM/YYYY');
            }
            this.setState({
                displayValue: displayValue
            });
        }
    }, {
        key: 'customCleanFiltered',
        value: function customCleanFiltered() {
            this.setState({
                from: null,
                to: null,
                displayValue: ''
            });
            this.props.filterHandler(); // clear filter
        }
    }, {
        key: 'filter',
        value: function filter() {
            if (_moment2.default.isDate(this.state.from)) {
                var fromValue = (0, _moment2.default)(this.state.from).format('YYYY-MM-DD');
                var toValue = void 0;
                if (_moment2.default.isDate(this.state.to)) {
                    this.setDisplayValue(this.state.from, this.state.to);
                    toValue = (0, _moment2.default)(this.state.to).hours(23).minutes(59).seconds(59).format('YYYY-MM-DD HH:mm:ss');
                } else {
                    this.setDisplayValue(this.state.from, this.state.from);
                    toValue = (0, _moment2.default)(this.state.from).hours(23).minutes(59).seconds(59).format('YYYY-MM-DD HH:mm:ss');
                }
                this.props.filterHandler({
                    values: {
                        from: fromValue,
                        to: toValue
                    },
                    type: 'between'
                });
            } else {
                this.setState({
                    displayValue: ''
                });
                this.props.filterHandler(); // clear filter
            }
            this.windowClick();
        }
    }, {
        key: 'addEvents',
        value: function addEvents() {
            window.addEventListener('click', this.windowClick, false);
            window.addEventListener('scroll', this.positionPicker, false);
            window.addEventListener('resize', this.positionPicker, false);
        }
    }, {
        key: 'removeEvents',
        value: function removeEvents() {
            window.removeEventListener('click', this.windowClick);
            window.removeEventListener('scroll', this.positionPicker);
            window.removeEventListener('resize', this.positionPicker);
        }
    }, {
        key: 'windowClick',
        value: function windowClick() {
            this.setState({
                showPicker: false,
                topPosition: 0,
                leftPosition: -1000
            });
            this.removeEvents();
        }
    }, {
        key: 'positionPicker',
        value: function positionPicker() {
            var parentPosition = (0, _getPosition2.default)(document.getElementById(this.props.columnKey + '-date-filter'));
            var elemWidth = document.getElementById(this.props.columnKey + '-date-filter-container').offsetWidth;
            var elemHeight = document.getElementById(this.props.columnKey + '-date-filter-container').offsetHeight;
            var rightOfElement = parentPosition.x + elemWidth;
            var bottomOfElement = parentPosition.y + elemHeight;

            var rightOfScreen = document.documentElement.offsetWidth;
            var bottomOfScreen = document.documentElement.offsetHeight;

            var leftAdjustmentPadding = 2;
            var leftAdjustment = Math.max(rightOfElement + leftAdjustmentPadding - rightOfScreen, 0);
            var topAdjustmentPadding = 3;
            var topAdjustment = Math.max(bottomOfElement + topAdjustmentPadding - bottomOfScreen, -22);

            this.setState({
                topPosition: parentPosition.y - topAdjustment,
                leftPosition: parentPosition.x - leftAdjustment
            });
        }
    }, {
        key: 'togglePicker',
        value: function togglePicker() {
            this.removeEvents();

            var nextShowState = !this.state.showPicker;
            this.setState({
                showPicker: nextShowState,
                topPosition: 0,
                leftPosition: -1000
            });
            if (nextShowState) {
                this.positionPicker(nextShowState);
                this.addEvents();
            }
        }
    }, {
        key: 'render',
        value: function render() {
            var columnKey = this.props.columnKey;
            var _state = this.state,
                topPosition = _state.topPosition,
                leftPosition = _state.leftPosition,
                from = _state.from,
                to = _state.to,
                displayValue = _state.displayValue;

            // Render the Calendar

            return _react2.default.createElement(
                'div',
                { id: columnKey + '-date-filter', className: 'custom-date-filter filter' },
                _react2.default.createElement(
                    'span',
                    { onClick: this.togglePicker, className: 'filter-value' },
                    displayValue
                ),
                _react2.default.createElement(
                    'div',
                    {
                        className: 'dropContainer dropHide',
                        id: columnKey + '-date-filter-container',
                        style: {
                            position: 'fixed',
                            zIndex: 19,
                            top: topPosition,
                            left: leftPosition
                        }
                    },
                    _react2.default.createElement(
                        'div',
                        { className: 'fromToDate' },
                        _react2.default.createElement(_DateRangeInputField2.default, {
                            handleDayClick: this.handleDayClick,
                            from: from,
                            to: to
                        })
                    ),
                    _react2.default.createElement(
                        'div',
                        { style: { clear: 'both' } },
                        _react2.default.createElement(
                            'div',
                            {
                                id: 'cidCourseListFilterOkButton',
                                className: 'okButton filterButton',
                                onClick: this.filter
                            },
                            'OK'
                        ),
                        from && _react2.default.createElement(
                            'div',
                            {
                                id: 'cidCourseListFilterClearFilterButton',
                                className: 'clearFilterButton',
                                onClick: this.handleResetClick
                            },
                            'Clear Filter'
                        )
                    )
                )
            );
        }
    }]);

    return CustomDateFilter;
}(_react2.default.Component);

CustomDateFilter.propTypes = {
    filterHandler: _propTypes2.default.func.isRequired,
    columnKey: _propTypes2.default.string.isRequired,
    defaultValue: _propTypes2.default.object.isRequired
};

CustomDateFilter.defaultProps = {
    defaultValue: null
};

exports.default = CustomDateFilter;